/******************************************************************************
;  *       @ͺ                   : MS32F7223
;  *       @               : 2023.08.01
;  *       @˾/              : ΢-FAE
;  *       @΢             : http://www.sinomcu.com/
;  *       @Ȩ                   : 2023 ΢繫˾Ȩ.
;  *----------------------  ---------------------------------
;  *                   ʱʹȫֱ                       
******************************************************************************/
#ifndef USER
#define USER
#include "MS32F7223.h"

/*****************************************************************
;       Function : Define variables
;*****************************************************************/
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define DEF_SET_BIT0                0x01
#define DEF_SET_BIT1                0x02
#define DEF_SET_BIT2                0x04
#define DEF_SET_BIT3                0x08
#define DEF_SET_BIT4                0x10
#define DEF_SET_BIT5                0x20
#define DEF_SET_BIT6                0x40
#define DEF_SET_BIT7                0x80

#define DEF_CLR_BIT0                0xFE
#define DEF_CLR_BIT1                0xFD
#define DEF_CLR_BIT2                0xFB
#define DEF_CLR_BIT3                0xF7
#define DEF_CLR_BIT4                0xEF
#define DEF_CLR_BIT5                0xDF
#define DEF_CLR_BIT6                0xBF
#define DEF_CLR_BIT7                0x7F

#define SET                         1
#define RESET                       0
#define PASS                        1
#define FAIL                        0

#define USER_HANDMODE               1//0:Զģʽ1:ֶģʽ
#define USER_PAGEWRITE              1//0:ֽд1:ҳд

#define     BACK0()          RBS=0    //ַ0ҳ
#define     BACK1()          RBS=1    //ַ1ҳ  
//===============Field Protection Variables===============
u8 INT_BACK;
__at 0x007 u8 abuf;          //жϱıڴ洢 0
__at 0x008 u8 statusbuf;

//===============Global Variable===============
u8 cnt;
uint8_t g_count1,g_count2,g_count3;
uint16_t EE_READ;
__at 0x0050 uint16_t data_test[16];
__at 0x003e uint16_t FLASH_test_num;    //д
uint16_t FLASH_test_buff;               //Ի

//===============Global Function===============
void CLR_RAM(void);
void IO_Init(void);
void UART_Init(void);
void UART_Send_Byte(u8 dat);
void delay(uint16_t num);
void Sys_Init(void);

uint16_t FLASH_Read_Byte(uint8_t sar , uint8_t par, uint8_t war);
//ֶģʽ
void FLASH_Handmode_Write_Byte(uint8_t sar , uint8_t par, uint8_t war, uint16_t data);
void FLASH_Handmode_Write_PAGE(uint8_t sar , uint8_t par, uint16_t *data);
void FLASH_Handmode_ERASE_word(uint8_t sar , uint8_t par, uint8_t war);
void FLASH_Handmode_ERASE_PAGE(uint8_t sar , uint8_t par);
void FLASH_Handmode_ERASE_SECTOR(uint8_t sar);
//Զģʽ
void FLASH_Autotmode_Write_Byte(uint8_t sar , uint8_t par, uint8_t war, uint16_t data_addr);
void FLASH_Automode_Write_PAGE(uint8_t sar , uint8_t par, uint16_t data_addr);
void FLASH_Automode_ERASE_word(uint8_t sar , uint8_t par, uint8_t war);
void FLASH_Automode_ERASE_PAGE(uint8_t sar , uint8_t par);
void FLASH_Automode_ERASE_SECTOR(uint8_t sar);

//============Define  Flag=================
typedef union {
    unsigned char byte;
    struct
    {
        u8 bit0 : 1;
        u8 bit1 : 1;
        u8 bit2 : 1;
        u8 bit3 : 1;
        u8 bit4 : 1;
        u8 bit5 : 1;
        u8 bit6 : 1;
        u8 bit7 : 1;
    } bits;
}bit_flag;
volatile bit_flag flag1;

#define     FLAG_TIMER1_10MS    flag1.bits.bit0

#endif

/**************************** end of file *********************************************/
