/******************************************************************************
;  *       @ͺ                 : MS32F7223
;  *       @             : 2023.8.29
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢
;  *----------------------ժҪ---------------------------------
;  *                IIC_Slave(Ӳӻ)
;  *                ӻַ0xA0
;  *                IIC_SCL:P03
;  *                IIC_SDA:P02
;  *                ܣ
;  *                    IIC_MasterͨѶ
;  *                    1)յдݣIIC_test_buff
;  *                    2)յIIC_test_buff
;  *                    3)鳤Ĭ20ͨ궨IIC_DATA_LEN޸
;  *                עʹPDT1(P00)PCK1(P01)Կ
******************************************************************************/

#include "user.h"

u8 sr,iic_status;
u8 iic_tx_buffer[IIC_DATA_LEN],iic_tx_len,iic_tx_idx;
u8 iic_rx_buffer[IIC_DATA_LEN],iic_rx_len,iic_rx_idx;
u16 i;

/************************************************
;  *    @Function Name       : delay
;  *    @Description         : ȷʱ4M Լ10us
;  *    @IN_Parameter        : ʱʱ
;  *    @Return parameter    : 
;  ***********************************************/ 
void delay(uint16_t num)
{
    for (i = 0; i < num; i++)     
    {
        Nop();
    }
}
/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter        : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
    for(FSR0 = 0;FSR0 < 0xFF;FSR0++) 
    {
        INDF0 = 0x00;
    }
    FSR0 = 0xFF;
    INDF0 = 0x00;
    for(FSR1 = 0;FSR1 < 0x7F;FSR1++) 
    {
        INDF1 = 0x00;
    }
    FSR1 = 0x7F;
    INDF1 = 0x00; 
//1ҳRA
    BACK1();
    for(FSR1 = 0;FSR1 < 0x7F;FSR1 ++) 
    {
        INDF1 = 0;
    }
    FSR1 = 0x7F;
    INDF1 = 0;
    BACK0();
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
    IOP0 = 0;           //IOλ
    OEP0 = 0xFF;        //IOڷ      1:out       0:in
    PUP0 = 0;           //IO    1:enable    0:disable
    PDP0 = 0;           //IO    1:enable    0:disable
    P0ADCR = 0;         //IOѡ    1:ģ  0:ͨIO

    IOP1 = 0;           //IOλ
    OEP1 = 0xFF;        //IOڷ      1:out       0:in
    PUP1 = 0;           //IO    1:enable    0:disable
    PDP1 = 0;           //IO    1:enable    0:disable
    P1ADCR = 0;         //IOѡ    1:ģ  0:ͨIO
}
/************************************************
;  *    @Function Name       : IIC_Init
;  *    @Description         : IICʼ
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/  
void IIC_Init(void)
{
    OEP0 &= DEF_CLR_BIT2;    //SDA
    OEP0 &= DEF_CLR_BIT3;    //SCL

    IOP0 |= DEF_SET_BIT2 | DEF_SET_BIT3;
    

    IICCR0 = 0x51;              //ӻģʽ100KbpsͬԶSTOPʹ0IOѡIICר
    IICSR = 0x00;
    IICDR = 0x00;
    IICAR = 0xA0;               //ӻַ
    IICAAR = 0x00;
    IICAMR = 0x00;
    
    IICIF = 0;
    IICIE = 1;                  //IICжʹ
    IICEN = 1;                  //ʹIIC
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    IIC_Init();
    GIE  = 1;        
}
/************************************************
;  *    @Function Name       : main
;  *    @Description         : 
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/  
void main(void)
{
    Sys_Init();
    F_MASTER_WRITE = RESET;
    F_MASTER_READ = RESET;
    for(iic_tx_idx = 0;iic_tx_idx < 20;iic_tx_idx++)
    {
        iic_tx_buffer[iic_tx_idx]=iic_tx_idx+0x80;
    }
    while(1)
    {  
        if(IICSTPF==1)//ֹͣλ
        {
            if(iic_status == IIC_STS_RX)
            {
                iic_tx_idx = 0;
                IICDR = iic_tx_buffer[iic_tx_idx++];
                iic_status = IIC_STS_TX;
            }
            F_ADDR_SAME = 0;
        }
    }
}
/************************************************
;  *    @Function Name       : interrupt
;  *    @Description         : жϺ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void int_isr(void)__interrupt
{
__asm
    movra   _abuf
    swapar  _PFLAG
    movra   _statusbuf
__endasm;  
    INT_BACK = RBS;          //жϻݴ洢ҳ
    BACK0();                 //ݳѡ01

    /**********  IIC  **********/
    if(IICIF)
    {
        sr = IICSR;
        IICIF = 0;
        
        if(F_ADDR_SAME == 0) //ӻַƥ
        {
            if(sr & 0x08)
            {
                F_ADDR_SAME = 1;
                TACKS = 0;
            }
            else
            {
                TACKS = 1; 
            }
                
        }
        if(F_ADDR_SAME) //ַƥɹ
        {
            switch(iic_status)
            {
                case IIC_STS_RX:  //ӻ״̬
                    {
                        if((sr & 0x02)==0)
                        {
                            if(iic_rx_idx < IIC_DATA_LEN)
                            {
                                TACKS = 0; 
                                iic_rx_buffer[iic_rx_idx++] = IICDR;
                            }
                        }
                        break;
                    }
                case IIC_STS_TX:  //ӻ״̬
                    {
                        if(sr & 0x02)
                        {
                            if(iic_tx_idx > IIC_DATA_LEN)  //鳤ȷ0xff
                            {
                                IICDR = 0xff;    //
                                iic_tx_idx ++;
                            } 
                            else  //յݷ
                            {
                                IICDR = iic_tx_buffer[iic_tx_idx++];
                                
                            }
                        }
                        else
                        {
                                    iic_rx_idx = 0;
                                    iic_status = IIC_STS_RX;
                        }
                        break;
                    }
                case IIC_STS_BUSY://æµ
                    {
                        if(sr & 0x02)
                        {
                            IICDR = 0xFF;
                        }
                        break;
                    }
                case IIC_STS_IDLE://
                default:
                    {
                        if(sr & 0x02)
                        {
                            IICDR = 0xFF;
                        }
                        else
                        {
                            iic_rx_idx = 0;
                            iic_status = IIC_STS_RX;
                        }
                        break;
                    }
            }

        }
    }

    RBS = INT_BACK;          //˳жϻԭݴ洢ҳ
__asm
    swapar  _statusbuf
    movra   _PFLAG
    swapr   _abuf
    swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/