/******************************************************************************
;  *       @ͺ                 : MS32F7223
;  *       @             : 2023.8.29
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢
;  *----------------------  ---------------------------------
;  *                   ʱʹȫֱ                       
******************************************************************************/
#ifndef USER
#define USER
#include "MS32F7223.h"

/*****************************************************************
;       Function : Define variables
;*****************************************************************/
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long int
#define uint8_t  unsigned char
#define uint16_t unsigned int
#define uint32_t unsigned long int

#define DEF_SET_BIT0                0x01
#define DEF_SET_BIT1                0x02
#define DEF_SET_BIT2                0x04
#define DEF_SET_BIT3                0x08
#define DEF_SET_BIT4                0x10
#define DEF_SET_BIT5                0x20
#define DEF_SET_BIT6                0x40
#define DEF_SET_BIT7                0x80

#define DEF_CLR_BIT0                0xFE
#define DEF_CLR_BIT1                0xFD
#define DEF_CLR_BIT2                0xFB
#define DEF_CLR_BIT3                0xF7
#define DEF_CLR_BIT4                0xEF
#define DEF_CLR_BIT5                0xDF
#define DEF_CLR_BIT6                0xBF
#define DEF_CLR_BIT7                0x7F

#define SET                         1
#define RESET                       0
#define PASS                        1
#define FAIL                        0

#define IIC_WRITE_CMD               0
#define IIC_READ_CMD                1
#define EE_24C02_ADDR               0xA0
#define IIC_DATA_LEN                20

//״̬
#define IIC_STS_IDLE 0
#define IIC_STS_RX   1
#define IIC_STS_TX   2
#define IIC_STS_BUSY 3

#define     BACK0()          RBS=0    //ַ0ҳ
#define     BACK1()          RBS=1    //ַ1ҳ  
//===============Field Protection Variables===============
u8 INT_BACK;
__at 0x007 u8 abuf;          //жϱıڴ洢 0
__at 0x008 u8 statusbuf;

//===============Global Variable===============
//u8 temp,len;
//u8 IIC_test_buff[IIC_DATA_LEN];

//===============Global Function===============
void CLR_RAM(void);
void IO_Init(void);
void IIC_Init(void);
void IIC_Start(void);
void IIC_Write_Byte(u8 data);
u8 IIC_Read_Byte(void);
void delay(uint16_t num);
void Sys_Init(void);

//============Define  Flag=================
typedef union {
    unsigned char byte;
    struct
    {
        u8 bit0 : 1;
        u8 bit1 : 1;
        u8 bit2 : 1;
        u8 bit3 : 1;
        u8 bit4 : 1;
        u8 bit5 : 1;
        u8 bit6 : 1;
        u8 bit7 : 1;
    } bits;
}bit_flag;
volatile bit_flag flag1;

#define     F_MASTER_WRITE          flag1.bits.bit0 
#define     F_MASTER_READ           flag1.bits.bit1 
#define     F_IIC_DONE              flag1.bits.bit2 
#define     F_ADDR_SAME              flag1.bits.bit3 



#endif

/**************************** end of file *********************************************/
