/******************************************************************************
;  *       @ͺ                 : MS32F7223
;  *       @             : 2023.8.29
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2023 ΢
;  *----------------------ժҪ---------------------------------
;  *                 PWM
;  *                 PWM1   P04   Duty=20%  F=5K
;  *                 PWM2A  P02   Duty=20%  F=50K  
;  *                 FPWM2A P03   DT=4us
******************************************************************************/

#include "user.h"

u16 i;
/************************************************
;  *    @Function Name       : delay
;  *    @Description         : ȷʱ4M Լ10us
;  *    @IN_Parameter        : ʱʱ
;  *    @Return parameter    : 
;  ***********************************************/ 
void delay(uint16_t num)
{
    for (i = 0; i < num; i++)     
    {
        Nop();
    }
}
/************************************************
;  *    @Function Name       : CLR_RAM
;  *    @Description         : RAM
;  *    @IN_Parameter        : 
;  *    @Return parameter    : 
;  ***********************************************/ 
void CLR_RAM(void)
{
    for(FSR0 = 0;FSR0 < 0xFF;FSR0++) 
    {
        INDF0 = 0x00;
    }
    FSR0 = 0xFF;
    INDF0 = 0x00;
    for(FSR1 = 0;FSR1 < 0x7F;FSR1++) 
    {
        INDF1 = 0x00;
    }
    FSR1 = 0x7F;
    INDF1 = 0x00; 
//1ҳRA
    BACK1();
    for(FSR1 = 0;FSR1 < 0x7F;FSR1 ++) 
    {
        INDF1 = 0;
    }
    FSR1 = 0x7F;
    INDF1 = 0;
    BACK0();
}
/************************************************
;  *    @Function Name       : IO_Init
;  *    @Description         : ͨIO
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void IO_Init(void)
{
    IOP0 = 0;           //IOλ
    OEP0 = 0xFF;        //IOڷ      1:out       0:in
    PUP0 = 0;           //IO    1:enable    0:disable
    PDP0 = 0;           //IO    1:enable    0:disable
    P0ADCR = 0;         //IOѡ    1:ģ  0:ͨIO

    IOP1 = 0;           //IOλ
    OEP1 = 0xFF;        //IOڷ      1:out       0:in
    PUP1 = 0;           //IO    1:enable    0:disable
    PDP1 = 0;           //IO    1:enable    0:disable
    P1ADCR = 0;         //IOѡ    1:ģ  0:ͨIO
}
/************************************************
;  *    @Function Name       : TIMER1_PWM_Init
;  *    @Description         : ʱ1ʼ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void TIMER1_PWM_Init(void)
{
    T1CR |= DEF_SET_BIT6 | DEF_SET_BIT1;     //PWM,CPU,4Ƶ
    T1CNTH = 0x03;
    T1CNTL = 0xE8 - 1;
    T1LOADH = 0x03;           //1ms
    T1LOADL = 0xE8 - 1;
    T1DATAH = 0x00;           //20%
    T1DATAL = 0xC8;
    T1EN = 1;
}
/************************************************
;  *    @Function Name       : TIMER2_PWM_Init
;  *    @Description         : ʱ2ʼ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void TIMER2_PWM_Init(void)
{
    T2CR |= DEF_SET_BIT6 | DEF_SET_BIT5 | DEF_SET_BIT1;     //PWM,FPWM,CPU,4Ƶ
    T2CNT = 100 - 1;         //100us
    T2LOAD = 100 - 1;
    T2DATA = 20;             //ռձ20%
    T2DATB = 0;
    T2DATC = 0;

    PWM2CR0 = 0x00;
    PWM2CR1 = 0x03;          //4us
    PWM2CR2 = 0x00;

    T2EN = 1;
}
/************************************************
;  *    @Function Name       : Sys_Init
;  *    @Description         : ϵͳʼ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/  
void Sys_Init(void)
{
    GIE = 0;
    CLR_RAM();
    IO_Init();
    TIMER1_PWM_Init();
    TIMER2_PWM_Init();
    GIE  = 1;        
}
/************************************************
;  *    @Function Name       : main
;  *    @Description         : 
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/  
void main(void)
{
    Sys_Init();
    while(1)
    {   

    }
}
/************************************************
;  *    @Function Name       : interrupt
;  *    @Description         : жϺ
;  *    @IN_Parameter        : 
;  *    @Return parameter    :
;  ***********************************************/   
void int_isr(void)__interrupt
{
__asm
    movra   _abuf
    swapar  _PFLAG
    movra   _statusbuf
__endasm; 
    INT_BACK = RBS;          //жϻݴ洢ҳ
    BACK0();                 //ݳѡ01

    // /**********  T0  **********/
    // if(T0IE & T0IF)
    // {
    //     T0IF = 0;
    //     P13D = !P13D;
    // }

    RBS = INT_BACK;          //˳жϻԭݴ洢ҳ
__asm
    swapar  _statusbuf
    movra   _PFLAG
    swapr   _abuf
    swapar  _abuf
__endasm;
}


/**************************** end of file *********************************************/